% Program for WT smoothng of an experimental chromatogram
%
% Input:
%    chromat.dat, figure 5.17
%
% Output:
%    figure 5.17
%    figure 5.18 (a)
%
    clear;
%
% input original data
%
   load chromat.dat;
	x=chromat(:,1);
	y=chromat(:,2);
%   
% make wavelet filter
%
	f=makeonfilter('Symmlet',4);
%   
% set resolution level J = dyadlength(y) -5
%
   J0=5;
%
% perform FWT
%
   wc=fwt_po(y,J0,f);
%
% perform smoothing
%
	[n,J]=dyadlength(wc);
   for j=J-1:-1:J0
     if j>J-5
       pat = dyad(j);
 	    wct(dyad(j)) = zeros(size(pat));
	  else
	    wct(dyad(j)) = wc(dyad(j));
	  end
	end
   wct(1:(2^J0)) = wc(1:(2^J0));
   yysm = iwt_po(wct,J0,f);
%
% display figure 5.17 and figure 5.18(a)
%
   figure; hold on;
   axis([1.3 12 -0.013 0.037]);
   plot(x,y);
   plot(x,yysm,'r');
%
% dispaly RMS
%
   disp(rms(yysm'-y));
%   
% end of program
%