% Program for WT smoothng of an experimental chromatogram
%
% Input:
%    chromat.dat, Figure 5.17
%
% Output:
%    figure 5.17
%    figure 5.18 (b)
%
    clear;
%
% input original data
%
   load chromat.dat;
	x=chromat(:,1)';
	y=chromat(:,2)';
%   
% make wavelet filter
%
	qmf=makeonfi('Daubechies',4);
	H=qmf;
	G=mirrorfi(H);
%   
% set resolution level J = 4
%
   J = 4;
%
% perform FWT
%
   yy=y;
	for i=1:J
	  [cc(i,:),dd(i,:)]=dvi22(yy,H,G);
	  H=upsample(H);
	  G=upsample(G);
	  yy=cc(i,:);
 	end
%
% perform smoothing
%
   ccc=cc(J,:);
	for i=J:-1:1
	  H=down(H); 
     G=down(G); 
     if i>4 ddd=dd(i,:);
     else ddd=zeros(size(dd(i,:)));
     end
	  ccc=confrom2(ccc,ddd,H,G);
	end
%
% display figure 5.17 and figure 5.18(b)
%
   figure; hold; 
   axis([1.3 12 -0.013 0.037]);
   plot(x,y); 
   plot(x,ccc,'r');
%
% dispaly RMS
%
   disp(rms(ccc-y));
%
% end of program
%
 