% Program for WPT denoising
%
% Output:
%    figure 5.19(b)
%
   clear;
%    
% Generate original data, Figure 5.14 (b)
%
   params = [7 2 0.7; ...
             7 4.2 0.7; ...
             7 5.2 0.7; ...
             7 7.5 0.7; ...
             3 8.5 0.7];
   x = 0.005:10/1024:10;
   y = mgauss(x,params);
   y = y./max(y);
   noise = rand(size(y))-0.5;
   y = y + 0.1*noise;
   x = x(:);
   y = y(:);   
%   
% make wavelet filter
%
	qmf = makeonfilter('Symmlet',4);
%   
%  set threshold
%
   Jth = 4; % Jth must be less than log10(n)/log10(2); 
   Pth = 0; % Pth must be in 0 - 2.^D-1;
   th  = packnum(Jth,Pth);
%
% perform WPT decomposition
%
   D  = Jth;
	wp = wpdecomp(y,D,qmf);   
%   
% perform WPT reconstruction   
%
   m = packnum(D,0);
	n = packnum(D,2.^D-1);
   y1=wprecon(wp(:,m:n),D,qmf,th);
%
% display figure 5.19(b)
%
   plot(x,y,x,y1,'r');
%
% end of program
%