function coefs = cwt_m(signal,scale)
% CWT with morlet wavelet basis
%
   signal = signal(:)';
   len = length(signal);
   coefs = zeros(1,len);
   precis = 10;
   [psi,psi_x] = feval('morlet_m',-8,8,2.^precis);
   f = get_filt(psi,psi_x,scale);
   coefs = -sqrt(scale)*keepcent(diff(conv(signal,f)),len);
%
% end of function
%