% Program for background removal by using CWT
%
   clear;
%
% signal simulation
%
   x=1:2048;
   x1=1:2:2048;
%
% signal No.1 (signal)
%
   omega0=5;
   omega1=0.2*pi;
   decay1=1/200;
   am1=1;
   y1=am1.*exp(-decay1*x).*cos(omega1*x);
   y11=abs(fft(y1));
   y11=y11(1:1024);
%
% signal 2 (background)
%
   omega2=0.19*pi;
   decay2=1/100;
   am2=10;
   y2=am2.*exp(-decay2*x).*cos(omega2*x);
   y21=abs(fft(y2));
   y21=y21(1:1024);
%
% mix the signals
%
   y=y1+y2;
   yy=abs(fft(y));
   yy=yy(1:1024);
%
% display figure 5.30
%
   figure;
   minfy = min(yy);   maxfy = max(yy);
   minsy = min(y);    maxsy = max(y);
   subplot(3,2,1); hold; axis([0 1000 minsy maxsy]); plot(x,y);
   subplot(3,2,3); hold; axis([0 1000 minsy maxsy]); plot(x,y1);
   subplot(3,2,5); hold; axis([0 1000 minsy maxsy]); plot(x,y2);
   subplot(3,2,2); hold; axis([0 800 minfy maxfy]); plot(x1,yy);
   subplot(3,2,4); hold; axis([0 800 minfy maxfy]); plot(x1,y11);
   subplot(3,2,6); hold; axis([0 800 minfy maxfy]); plot(x1,y21);
%
% background removal by CWT
%
   a=omega0/omega1;
   p=pi;
   co=y;
   for i=1:500
     c=cwt_m(co./sqrt(2*p),a);
     co=c;
     cc=abs(fft(c));
     cft=cc(1:1024);
     if (i==100)
        c100=c';
        cft100=cft';
     end
     if (i==300)
        c300=c';
        cft300=cft';
     end
     if (i==500)
        c500=c';
        cft500=cft';
     end
   end
%
% display figure 5.31
%
   figure;
   subplot(3,2,1); hold; 
   axis([0 1500 min(c500) max(c500)]); plot(x,c500);
   subplot(3,2,3); hold;
   axis([0 1500 min(c300) max(c300)]); plot(x,c300);
   subplot(3,2,5); hold;
   axis([0 1500 min(c100) max(c100)]); plot(x,c100);
   subplot(3,2,2); hold;
   axis([0 800 min(cft500) max(cft500)]); plot(x1,cft500);
   subplot(3,2,4); hold;
   axis([0 800 min(cft300) max(cft300)]); plot(x1,cft300);
   subplot(3,2,6); hold;
   axis([0 800 min(cft100) max(cft100)]); plot(x1,cft100);
%
% end of program
%
