function y = mlorentz(x,param) 
% Function for simulation of NMR spectra
% with Lorentzian function.
%
   [m,n] = size(param);
   if n ~= 3 disp('Warning!!'); return; end
%   
   x = x(:)';
   y = zeros(size(x));
   for i=1:m
      out = param(i,1)*(1+4*((x-param(i,2))/param(i,3)).^2).^(-1);
      y = y + out;
   end   
%   
% end of function.
%
